package com.zink.scala.fly.stub

import com.zink.scala.fly.{FieldCodec, FlyPrime}
import com.zink.scala.fly.FlyAccessException._

import java.io.ByteArrayInputStream
import java.io.ByteArrayOutputStream
import java.io.ObjectInputStream
import java.io.ObjectOutputStream

class SerializingFieldCodec extends FieldCodec {

  // buffer for coding objects into byte arrays
  private val bos = new ByteArrayOutputStream(FlyPrime.DEFAULT_BUFFER_SIZE)

  override def writeField(field: AnyRef): Array[Byte] = wrapExceptionIfThrown {
      bos.reset()
      val oos = new ObjectOutputStream(bos)
      oos.writeObject(field)
      oos.flush()
      bos.toByteArray()
    }

  override def readField(fieldBytes: Array[Byte]): Option[AnyRef] = wrapExceptionIfThrown {
	  Option(new ObjectInputStream(new ByteArrayInputStream(fieldBytes)).readObject)
  }
}
